# coding: utf-8

"""
    LUSID Website API

    FINBOURNE Technology  # noqa: E501

    The version of the OpenAPI document: 0.4.1357
    Contact: info@finbourne.com
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from lusid_web_app.configuration import Configuration


class Mapping(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
      required_map (dict): The key is attribute name
                           and the value is whether it is 'required' or 'optional'.
    """
    openapi_types = {
        'scope': 'str',
        'code': 'str',
        '_for': 'str',
        'rules': 'list[MappingRule]'
    }

    attribute_map = {
        'scope': 'scope',
        'code': 'code',
        '_for': 'for',
        'rules': 'rules'
    }

    required_map = {
        'scope': 'optional',
        'code': 'optional',
        '_for': 'optional',
        'rules': 'optional'
    }

    def __init__(self, scope=None, code=None, _for=None, rules=None, local_vars_configuration=None):  # noqa: E501
        """Mapping - a model defined in OpenAPI"
        
        :param scope:  The scope for this mapping.
        :type scope: str
        :param code:  The code for this mapping.
        :type code: str
        :param _for:  What type of reconciliation this mapping is for
        :type _for: str
        :param rules:  The rules in this mapping, keyed by the source field/proeprty name
        :type rules: list[lusid_web_app.MappingRule]

        """  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._scope = None
        self._code = None
        self.__for = None
        self._rules = None
        self.discriminator = None

        self.scope = scope
        self.code = code
        self._for = _for
        self.rules = rules

    @property
    def scope(self):
        """Gets the scope of this Mapping.  # noqa: E501

        The scope for this mapping.  # noqa: E501

        :return: The scope of this Mapping.  # noqa: E501
        :rtype: str
        """
        return self._scope

    @scope.setter
    def scope(self, scope):
        """Sets the scope of this Mapping.

        The scope for this mapping.  # noqa: E501

        :param scope: The scope of this Mapping.  # noqa: E501
        :type scope: str
        """

        self._scope = scope

    @property
    def code(self):
        """Gets the code of this Mapping.  # noqa: E501

        The code for this mapping.  # noqa: E501

        :return: The code of this Mapping.  # noqa: E501
        :rtype: str
        """
        return self._code

    @code.setter
    def code(self, code):
        """Sets the code of this Mapping.

        The code for this mapping.  # noqa: E501

        :param code: The code of this Mapping.  # noqa: E501
        :type code: str
        """

        self._code = code

    @property
    def _for(self):
        """Gets the _for of this Mapping.  # noqa: E501

        What type of reconciliation this mapping is for  # noqa: E501

        :return: The _for of this Mapping.  # noqa: E501
        :rtype: str
        """
        return self.__for

    @_for.setter
    def _for(self, _for):
        """Sets the _for of this Mapping.

        What type of reconciliation this mapping is for  # noqa: E501

        :param _for: The _for of this Mapping.  # noqa: E501
        :type _for: str
        """

        self.__for = _for

    @property
    def rules(self):
        """Gets the rules of this Mapping.  # noqa: E501

        The rules in this mapping, keyed by the source field/proeprty name  # noqa: E501

        :return: The rules of this Mapping.  # noqa: E501
        :rtype: list[lusid_web_app.MappingRule]
        """
        return self._rules

    @rules.setter
    def rules(self, rules):
        """Sets the rules of this Mapping.

        The rules in this mapping, keyed by the source field/proeprty name  # noqa: E501

        :param rules: The rules of this Mapping.  # noqa: E501
        :type rules: list[lusid_web_app.MappingRule]
        """

        self._rules = rules

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Mapping):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Mapping):
            return True

        return self.to_dict() != other.to_dict()
